#ifndef EXTRAKEYBOARD_H
#define EXTRAKEYBOARD_H

#include <cstdint>


enum
{
    MYKEY_F1=0,
    MYKEY_F2,
    MYKEY_F3,
    MYKEY_F4,
    MYKEY_F5,
    MYKEY_F6,
    
    MYKEY_SHIFT,
    MYKEY_OPTN,
    MYKEY_VARS,
    MYKEY_MENU,
    MYKEY_LEFT,
    MYKEY_UP,

    MYKEY_ALPHA,
    MYKEY_SQUARE,
    MYKEY_POWER,
    MYKEY_EXIT,
    MYKEY_DOWN,
    MYKEY_RIGHT,

    MYKEY_XOT,
    MYKEY_LOG,
    MYKEY_LN,
    MYKEY_SIN,
    MYKEY_COS,
    MYKEY_TAN,

    MYKEY_FRAC,
    MYKEY_FD,
    MYKEY_LEFTP,
    MYKEY_RIGHTP,
    MYKEY_COMMA,
    MYKEY_ARROW,

    MYKEY_7,
    MYKEY_8,
    MYKEY_9,
    MYKEY_DEL,

    MYKEY_4,
    MYKEY_5,
    MYKEY_6,
    MYKEY_MUL,
    MYKEY_DIV,

    MYKEY_1,
    MYKEY_2,
    MYKEY_3,
    MYKEY_ADD,
    MYKEY_SUB,

    MYKEY_0,
    MYKEY_DOT,
    MYKEY_EXP,
    MYKEY_NEG,
    MYKEY_EXE,

    MYKEY_ACON,

    MYKEY_LASTENUM,
};



class KeyboardExtra
{
    public:
        KeyboardExtra();
        ~KeyboardExtra();

        void Update( float dt );
        bool IsKeyPressedEvent( int key );
        bool IsKeyReleasedEvent( int key );
        bool IsKeyPressed( int key );
        bool IsKeyReleased( int key );
        uint32_t IsKeyHoldPressed( int key );
        uint32_t IsKeyHoldReleased( int key );
        uint32_t GetLastTickKeyEvent( int key );

    private:
        uint32_t now;
};


#endif
